# -*- coding: utf-8 -*-
##############################################################################
#
#    cyclofficine_pantin module for OpenERP, Custom module for La Cyclofficine
#    de Pantin

#    Copyright (C) 2015-2016 cyclofficine_pantin
#    (<http://cyclocoop.org/index.php/les-ateliers/pantin/>)
#
#    This file is a part of cyclofficine_pantin
#
#    cyclofficine_pantin is free software: you can redistribute it and/or
#    modify it under the terms of the GNU General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or (at
#    your option) any later version.
#
#    cyclofficine_pantin is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import osv
from openerp.osv import orm
from openerp.osv import fields


class Partner(orm.Model):
    _inherit = 'res.partner'

    _order = 'member_ident,name asc'

    def _check_member_ident_length(self, cr, uid, ids, context=None):
        # Check if member ident length is equal to sequence padding.
        sequences = self.pool.get('ir.sequence')
        id_mb_seq = sequences.search(cr, uid,
                                     [('name', '=', 'Member identifier')],
                                     limit=1, context=context)
        mb_sequences = sequences.browse(cr, uid, id_mb_seq, context=context)

        partners = self.browse(cr, uid, ids, context=context)
        for mb_seq in mb_sequences:
            padding = mb_seq.padding

        for partner in partners:
            if partner.member_ident:
                mb_ident_length = len(partner.member_ident)
                if not mb_ident_length == padding:
                    return False

        return True

    _constraints = [
        (_check_member_ident_length,
         'This member indentifier has not a good length.', ['member_ident']),
    ]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
